diff -uNr hcpm.org/content/hcpm/hcpmHistUtils.js hcpm/content/hcpm/hcpmHistUtils.js
--- hcpm.org/content/hcpm/hcpmHistUtils.js	2005-09-11 01:53:40.000000000 +0900
+++ hcpm/content/hcpm/hcpmHistUtils.js	2006-01-25 02:17:56.000000000 +0900
@@ -75,8 +75,8 @@
 	  if(aPref && aToggle != true) { //means pref change
 	     var oldSetting = gPrefService.getBoolPref("hcpm.Show.Always"); 
 	       gPrefService.setBoolPref("hcpm.Show.Always", !oldSetting); 
+	     aToggle = true; //set to "true", to show menu if hidden
 	     if(oldSetting == false) {//Since "show all menus" has been checked
-		aToggle = true; //set to "true", to show menu if hidden
 		stayOpen = true;//force to stay open
 		}	
              }
@@ -135,10 +135,15 @@
 	}
 var historyMenuItems = document.getElementById('history-menu').childNodes;
 var i = 0;
- 	for (i = 0; i < historyMenuItems.length; i++)
+	for (i = 0; i < historyMenuItems.length - 1; i++)
 	{ 
 	   (aToggle) ? historyMenuItems[i].setAttribute("ehmMode", "icon") : historyMenuItems[i].setAttribute("ehmMode", "text"); 
-    	}
+	}
+	historyMenuItems = historyMenuItems[historyMenuItems.length - 1].childNodes;
+	for (i = 0; i < historyMenuItems.length; i++)
+	{ 
+	   (aToggle) ? historyMenuItems[i].setAttribute("ehmMode", "icon") : historyMenuItems[i].setAttribute("ehmMode", "text"); 
+	}
 }  
 
 function matchListFlip() {
diff -uNr hcpm.org/content/hcpm/history/history.js hcpm/content/hcpm/history/history.js
--- hcpm.org/content/hcpm/history/history.js	2005-10-08 01:34:00.000000000 +0900
+++ hcpm/content/hcpm/history/history.js	2006-01-22 17:38:32.000000000 +0900
@@ -338,8 +338,11 @@
            OpenURLArrayInTabs(URLArray);
        }
      }        
-     else if (!isContainer(gHistoryTree, currentIndex))
-       openTopWin(url);
+     else if (!isContainer(gHistoryTree, currentIndex)) {
+       //openTopWin(url);
+       var URLArray = [url];
+       OpenURLArrayInTabs(URLArray);
+     }
      return true;
  }
 
diff -uNr hcpm.org/content/hcpm/historyComm.xul hcpm/content/hcpm/historyComm.xul
--- hcpm.org/content/hcpm/historyComm.xul	2005-09-03 08:43:26.000000000 +0900
+++ hcpm/content/hcpm/historyComm.xul	2006-01-25 01:58:02.000000000 +0900
@@ -80,7 +80,9 @@
 		accesskey="&findHisCmd.accesskey;" oncommand="showAdvToolbar(false, true);"/>
     <toolbarbutton id="full-list-button" label="&full-list.label;" accesskey="&full-list.accesskey;" tooltiptext="&full-list.tooltip;" 
 		hidden="true" oncommand="GroupBy(gPrefService.getCharPref('browser.history.grouping')); gSearchField.value='';"/> 
-<toolbarbutton id="menu_View" type="menu">
+
+<menubar style="border:0px;padding:0px;margin:0px;-moz-appearance:none">
+<menu id="menu_View" class="menu-iconic">
     <menupopup onpopupshowing="fillViewMenu(this)">
       <menu id="groupingMenu" label="&groupBy.label;" accesskey="&groupBy.accesskey;">
         <menupopup>
@@ -105,8 +107,8 @@
         accesskey="&menuitem.view.descending.accesskey;"
         oncommand="return SortInNewDirection('descending');"/>
     </menupopup>
-  </toolbarbutton>
-  <toolbarbutton id="menu_Edit"  type="menu" onpopupshowing="document.commandDispatcher.updateCommands('select');">
+  </menu>
+  <menu id="menu_Edit" onpopupshowing="document.commandDispatcher.updateCommands('select');" class="menu-iconic">
     <menupopup >
       <menuitem id="menu_cut"/>
       <menuitem id="menu_copy"/>
@@ -118,16 +120,17 @@
       <menuseparator/>
       <menuitem id="menu_selectAll"/>
     </menupopup>
-  </toolbarbutton>
-  <toolbarbutton id="moreSettings" label="&moreSettings.label;" type="menu" onpopupshowing="hcpmHistUtils.updateSettingsLabel() ">
+  </menu>
+  <menu id="moreSettings" label="&moreSettings.label;" onpopupshowing="hcpmHistUtils.updateSettingsLabel() " class="menu-iconic">
     <menupopup >
 	<menuitem id="ehm-icon-mode" label="&iconmode.label;" type="checkbox" oncommand="ehmIconMode(true);"/> 
        <menuitem id="toolbar-always" label="&showAlways.label;" type="checkbox" oncommand="showAdvToolbar(true);"/> 
        <menuitem id="rapidSearch" label="&rapidAlways.label;" type="checkbox" oncommand="toggleRapidSearch(true);"/>
     </menupopup>
-   </toolbarbutton>
-   <toolbarbutton id="windowMenu" type="menu" />
+   </menu>
+   <menu id="windowMenu" type="menu" class="menu-iconic" />
     <menupopup/>
+</menubar>
 </toolbar>
 
 <toolbar id="history-menu2">
diff -uNr hcpm.org/skin/classic/hcpm/hcpm.css hcpm/skin/classic/hcpm/hcpm.css
--- hcpm.org/skin/classic/hcpm/hcpm.css	2005-06-05 20:00:16.000000000 +0900
+++ hcpm/skin/classic/hcpm/hcpm.css	2006-01-25 02:20:42.323297600 +0900
@@ -60,7 +60,8 @@
 }
 
 /*Remove labels from buttons (Icon Mode) */
-toolbarbutton[ehmMode="icon"] > .toolbarbutton-text {
+toolbarbutton[ehmMode="icon"] > .toolbarbutton-text,
+menu[ehmMode="icon"] > .menubar-text {
  display: none;
 }
 
